/*
Fallen Star Super Sonic
By JosephLol and the Game
Sonic And The Fallen Star by StarDrop
codes: Reverie Super Sonic
*/
freeslot(
"sfx_spdash")
sfxinfo[sfx_spdash].caption = "Super Dash"
addHook("PlayerThink",  function(p)
    -- Only Sonic can be Super Sonic
    if not (p.mo and p.mo.valid and p.mo.skin == "nsonic")
        return
    end
   
    -- Only Super people can be Super Sonic
    if not p.powers[pw_super]
        -- Take your old ability back, normie, we're done here
        if p.eggoldability != nil
            p.charability = p.eggoldability
            p.eggoldability = nil
        end
        -- Non-super people can't be super-flying
        p.eggsuperflying = false
        return
    end
   
    -- Not not Sonic, not not Super, must be Super Sonic!
    -- Play that sick tune
    if not (p.powers[pw_extralife]) and p.eggmusic == 1
        S_ChangeMusic("EGGR",true,p)
    end
   
    -- Can't go flying if you're in a minecart or a zoom tube
    if p.mo.state == S_PLAY_RIDE or p.powers[pw_carry] == CR_ZOOMTUBE
        return
    end
   
    -- Definitely flying, so initialise/confirm flying-related variables
    p.eggsuperflying = $ or false  -- Boolean for whether Super Sonic is flying
    p.eggflystart = $ or false -- Boolean for whether Super Sonic just started flying
    p.eggflyboost = $ or false  -- Boolean for whether Super Sonic can boost this tic
    p.eggboostcost = 5  -- How many rings it costs to boost
    p.eggmaxvert = 22*FRACUNIT  -- Maximum vertical flying speed in either direction
    p.eggoldability = $ or CA_NONE -- Storage for non-super jump ability
   
    -- If you still have a jump ability, take it away and remember what it was
    if p.charability != CA_NONE
        p.charability, p.eggoldability = CA_NONE, $1
    end
   
    -- You stop flying when you touch the ground
    if P_IsObjectOnGround(p.mo)
        p.eggsuperflying = false
    else
    -- Prevent rolling when holding spin and touching ground while flying.
        p.pflags = $ | PF_THOKKED|PF_CANCARRY
    end
   
    -- If you're not flying right now, we're done here.
    if not p.eggsuperflying
        return
    end
   
    -- Gravity doesn't apply when you're flying
    p.mo.momz = $-P_GetMobjGravity(p.mo)
   
    -- You can't fall when you're flying
    if p.mo.state == S_PLAY_FALL
        p.mo.state = S_PLAY_FLOAT
    end
   
    -- You're not jumping or spinning when you're flying
	p.pflags = $ & ~PF_JUMPED & ~PF_SPINNING
   
    -- You have to let go of jump after you start floating before you can ascend
    if not (p.cmd.buttons & BT_JUMP)
        p.eggflystart = false
    end
	
	--Prevent stored momentum when initiating hover
	if p.eggflystart == true and p.eggflymode == 1 
		P_SetObjectMomZ(p.mo, 0*FRACUNIT)
	end
   
    -- You have to let go of either jump or spin after boosting before you can boost again
    if not (p.cmd.buttons & BT_USE) or not (p.cmd.buttons & BT_JUMP)
        p.eggflyboost = true
    end
   
    -- If you're holding jump and not spin, accelerate up
    if (p.cmd.buttons & BT_JUMP) and not (p.cmd.buttons & BT_USE) and not p.eggflystart or (p.cmd.buttons & BT_JUMP) and not (p.cmd.buttons & BT_USE) and p.eggflymode == 2
        P_SetObjectMomZ(p.mo, 1*FRACUNIT, true) -- Accelerate up
    end
   
    -- If you're holding spin and not jump, accelerate down
    if (p.cmd.buttons & BT_USE) and not (p.cmd.buttons & BT_JUMP)
        P_SetObjectMomZ(p.mo, -1*FRACUNIT, true)
    end
   
    -- Cap the max flying speed at both ends
    p.mo.momz = max(min(p.eggmaxvert, p.mo.momz), 0-p.eggmaxvert)
   
    -- If you're holding neither, come to a halt
    if not (p.cmd.buttons & BT_JUMP) and not (p.cmd.buttons & BT_USE)
        p.mo.momz = abs($)>FRACUNIT and $*9/10 or 0
    end
end)
 
addHook("AbilitySpecial", function(p)
    if p.mo.skin == "nsonic" and p.mo and p.mo.valid
    and p.powers[pw_super] and not p.eggsuperflying
        p.eggsuperflying = true
        p.eggflystart = true
        p.mo.state = S_PLAY_FLOAT
        return true
    end
    return false
end)

//This code is existed to EX Movesets, and this is my code, Dont Stole this. -JosephLol
addHook("PlayerThink", function(player)
	local mo = player.mo
	if not (mo and mo.valid and mo.skin == "nsonic") return false end
		if player.eggsuperflying or (mo.state == S_PLAY_FLOAT or mo.state == S_PLAY_FLOAT_RUN)
		
		if player.flightdashtimer == nil
			player.flightdashtimer = 0
		end
		
		if player.flightdashtrailtimer == nil
			player.flightdashtrailtimer = 0
		end
		
		if player.safsnovasoniccircle == nil
			player.safsnovasoniccircle = 0
		end
		
		if player.flightdashtimer > 0
			player.flightdashtimer = $ - 1
		end
	
		if player.flightdashtrailtimer > 0
			player.flightdashtrailtimer = $ - 1
			local AfterImageSpawn = P_SpawnGhostMobj(mo)
			AfterImageSpawn.color = mo.color
			AfterImageSpawn.colorized = true
			AfterImageSpawn.rollangle = mo.rollangle
		end
		if player.safsnovasoniccircle > 0
			player.safsnovasoniccircle = $ - 1
			if not (leveltime % 5)
			local thok = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
			thok.state = S_FACESTABBERSPEAR
			thok.color = SKINCOLOR_WHITE
			thok.angle = player.drawangle+ANGLE_90
			thok.scale = player.mo.scale/2+FRACUNIT/4
			thok.fuse = 8
			thok.colorized = true
			thok.blendmode = AST_ADD
			end
		end

		if ((player.cmd.buttons & BT_CUSTOM1) and not player.dashbutton)
				player.flightdashtimer = 20
				player.flightdashtrailtimer = 5
				if player.cmd.forwardmove or player.cmd.sidemove // momentum reshift
				P_InstaThrust(mo,mo.angle,FixedMul(90*FRACUNIT,mo.scale))
				player.safsnovasoniccircle = 10
				end
				if (player.cmd.buttons & BT_JUMP) and not (player.cmd.buttons & BT_USE)
					P_SetObjectMomZ(mo, 50*FRACUNIT, true) -- Accelerate up
				end
				if (player.cmd.buttons & BT_USE) and not (player.cmd.buttons & BT_JUMP)
					P_SetObjectMomZ(mo, -50*FRACUNIT, true)
				end
				S_StartSound(mo, sfx_zoom)
			if in2d
				P_InstaThrust(mo, mo.angle, FixedHypot(mo.momx, mo.momy))
			else
				P_InstaThrust(mo, player.cmd.angleturn << 16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove*FRACUNIT), FixedHypot(mo.momx, mo.momy)) // hi Rumia
			end
		end
		if (player.cmd.buttons & BT_CUSTOM1)
			player.dashbutton = true
		else
			player.dashbutton = false
		end
	end
end)
